program TestTWI_Slave;

{$NOSHADOW}
{ $WG}                     {global Warnings off}

Device = mega128, VCC=5;
{ $BOOTRST $0F000}         {Reset Jump to $0F000}

Define_Fuses
//  Override_Fuses;
  NoteBook   = A;
  COMport    = USB;
  LockBits0 = [];
  FuseBits0  = [];
  FuseBits1  = [SPIEN,  OCDEN];
  FuseBits2  = [];

Import SysTick,SerPort,TWISlave;

From System Import ;


Define
  ProcClock      = 16000000;       {Hertz}
  SysTick        = 10;             {msec}
  StackSize      = $0064, iData;
  FrameSize      = $0064, iData;

  SerPort    = 9600, Stop1;
  TxBuffer   = 255 , IData;
  RxBuffer   = 4,  IData;

  TWIaddr     = 6;
  TWIBuffer   = 50,iData;
  TWImode     = transparent;//Handshake;
Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }

{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
var

StateHistory : array[0..10] of byte;
StateIdx : byte;
{--------------------------------------------------------------}
{ functions }
interrupt TWSI;
begin
  StateHistory[StateIdx]:= _TWISLRES;
  inc(StateIdx);
end;


{--------------------------------------------------------------}
{ Main Program }
{$IDATA}
var
 c : char;
 Info,Idx : byte;
begin
  FillBlock(@StateHistory,11,$FF);
  StateIdx :=0;

  EnableInts;
  loop
    if serstat then
      c:= Serinp;
      case c of
       'i': Info:= TWSR;
            writeln(serout,'StatusRegister:'+bytetohex(Info));
            Info:= _TWISLRWPTR;
            writeln(serout,'ReadWritePtr:'+bytetohex(Info));
            Info := _TWISLRES;
            writeln(serout,'TWISLRES:'+bytetohex(Info));|
       'd': writeln(serout,'DataBuffer:');
            for Idx := 1 to 50 do
              writeln(serout,Bytetohex(TWIRxBuffer[Idx]));
            endfor;|
       's': for Idx := 0 to 10 do
               writeln(serout,Bytetohex(StateHistory[Idx]));
            endfor;|
      endcase;
    endif;
  endloop;
end TestTWI_Slave.

