program TestTWI_Master;

{$NOSHADOW}
{ $WG}                     {global Warnings off}

Device = mega128, VCC=5;
{ $BOOTRST $0F000}         {Reset Jump to $0F000}

Define_Fuses
//  Override_Fuses;
  NoteBook   = A;
  COMport    = USB;
  LockBits0  = [];
  FuseBits0  = [];
  FuseBits1  = [SPIEN, OCDEN];
  FuseBits2  = [];

Import SysTick,TWIMaster,Serport;

From System Import ;


Define
  ProcClock      = 16000000;       {Hertz}
  SysTick        = 10;             {msec}
  StackSize      = $0064, iData;
  FrameSize      = $0064, iData;

  //Serport for Debugging
  SerPort    = 9600, Stop1;   	{38400 Baud, 1 StopBit}
  TxBuffer   = 80 , IData;
  RxBuffer   = 255, IData;

  TWIpresc    = TWI_BR100;  //100 kHz

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type
const
 TWI_Slave : byte = 6;

{--------------------------------------------------------------}
{ Const Declarations }

{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}


{--------------------------------------------------------------}
{ functions }



{--------------------------------------------------------------}
{ Main Program }
{$IDATA}
var
 c : char;
begin


  EnableInts;
  loop
    if serstat then
      c:= serinp;
      case c of
        's': TWIStat(TWI_Slave);|
        'o': TWIOut(TWI_Slave,$02,$55);|
      endcase;
    endif;
  endloop;
end TestTWI_Master.

